import { default as React } from 'react';
import { ListBoxItemProps, ListBoxProps, DragAndDropOptions } from 'react-aria-components';
type ListItem = {
    id: string | number;
    name: string;
    value: any;
};
interface IDraggableList extends Omit<ListBoxProps<ListBoxItemProps>, "items" | "selectionMode" | "dragAndDropHooks" | "selectionBehavior" | "orientation" | "onSelectionChange"> {
    items: ListItem[];
    dragDisabled?: boolean;
    deletionDisabled?: boolean;
    updateCallback?: (updatedItems: ListItem[]) => void;
    selectionCallback?: (list: ListItem) => void;
    renderDragPreview?: DragAndDropOptions["renderDragPreview"];
}
declare function DraggableList({ items, updateCallback, selectionCallback, className, renderDragPreview, dragDisabled, deletionDisabled, ...props }: Readonly<IDraggableList>): React.JSX.Element;
export default DraggableList;
