import { a as he } from "./useNumberFormatter-CO6iUSKG.js";
import { d as ge, c as xe } from "./Button-CXfbBbgl.js";
import { useRef as R, useEffect as I } from "react";
import { b as ve } from "./useHover-r8IM8mvD.js";
import { j as V } from "./utils-DPfg4HqB.js";
import { $ as Ee } from "./useLocalizedStringFormatter-BXegnzqm.js";
const Pe = new RegExp("^.*\\(.*\\).*$"), Se = [
  "latn",
  "arab",
  "hanidec",
  "deva",
  "beng"
];
class De {
  /**
  * Parses the given string to a number. Returns NaN if a valid number could not be parsed.
  */
  parse(e) {
    return F(this.locale, this.options, e).parse(e);
  }
  /**
  * Returns whether the given string could potentially be a valid number. This should be used to
  * validate user input as the user types. If a `minValue` or `maxValue` is provided, the validity
  * of the minus/plus sign characters can be checked.
  */
  isValidPartialNumber(e, t, r) {
    return F(this.locale, this.options, e).isValidPartialNumber(e, t, r);
  }
  /**
  * Returns a numbering system for which the given string is valid in the current locale.
  * If no numbering system could be detected, the default numbering system for the current
  * locale is returned.
  */
  getNumberingSystem(e) {
    return F(this.locale, this.options, e).options.numberingSystem;
  }
  constructor(e, t = {}) {
    this.locale = e, this.options = t;
  }
}
const A = /* @__PURE__ */ new Map();
function F(i, e, t) {
  let r = B(i, e);
  if (!i.includes("-nu-") && !r.isValidPartialNumber(t)) {
    for (let n of Se) if (n !== r.options.numberingSystem) {
      let o = B(i + (i.includes("-u-") ? "-nu-" : "-u-nu-") + n, e);
      if (o.isValidPartialNumber(t)) return o;
    }
  }
  return r;
}
function B(i, e) {
  let t = i + (e ? Object.entries(e).sort((n, o) => n[0] < o[0] ? -1 : 1).join() : ""), r = A.get(t);
  return r || (r = new Ne(i, e), A.set(t, r)), r;
}
class Ne {
  parse(e) {
    let t = this.sanitize(e);
    if (this.symbols.group && (t = D(t, this.symbols.group, "")), this.symbols.decimal && (t = t.replace(this.symbols.decimal, ".")), this.symbols.minusSign && (t = t.replace(this.symbols.minusSign, "-")), t = t.replace(this.symbols.numeral, this.symbols.index), this.options.style === "percent") {
      let m = t.indexOf("-");
      t = t.replace("-", "");
      let l = t.indexOf(".");
      l === -1 && (l = t.length), t = t.replace(".", ""), l - 2 === 0 ? t = `0.${t}` : l - 2 === -1 ? t = `0.0${t}` : l - 2 === -2 ? t = "0.00" : t = `${t.slice(0, l - 2)}.${t.slice(l - 2)}`, m > -1 && (t = `-${t}`);
    }
    let r = t ? +t : NaN;
    if (isNaN(r)) return NaN;
    if (this.options.style === "percent") {
      var n, o;
      let m = {
        ...this.options,
        style: "decimal",
        minimumFractionDigits: Math.min(((n = this.options.minimumFractionDigits) !== null && n !== void 0 ? n : 0) + 2, 20),
        maximumFractionDigits: Math.min(((o = this.options.maximumFractionDigits) !== null && o !== void 0 ? o : 0) + 2, 20)
      };
      return new De(this.locale, m).parse(new he(this.locale, m).format(r));
    }
    return this.options.currencySign === "accounting" && Pe.test(e) && (r = -1 * r), r;
  }
  sanitize(e) {
    return e = e.replace(this.symbols.literals, ""), this.symbols.minusSign && (e = e.replace("-", this.symbols.minusSign)), this.options.numberingSystem === "arab" && (this.symbols.decimal && (e = e.replace(",", this.symbols.decimal), e = e.replace("،", this.symbols.decimal)), this.symbols.group && (e = D(e, ".", this.symbols.group))), this.options.locale === "fr-FR" && (e = D(e, ".", " ")), e;
  }
  isValidPartialNumber(e, t = -1 / 0, r = 1 / 0) {
    return e = this.sanitize(e), this.symbols.minusSign && e.startsWith(this.symbols.minusSign) && t < 0 ? e = e.slice(this.symbols.minusSign.length) : this.symbols.plusSign && e.startsWith(this.symbols.plusSign) && r > 0 && (e = e.slice(this.symbols.plusSign.length)), this.symbols.group && e.startsWith(this.symbols.group) || this.symbols.decimal && e.indexOf(this.symbols.decimal) > -1 && this.options.maximumFractionDigits === 0 ? !1 : (this.symbols.group && (e = D(e, this.symbols.group, "")), e = e.replace(this.symbols.numeral, ""), this.symbols.decimal && (e = e.replace(this.symbols.decimal, "")), e.length === 0);
  }
  constructor(e, t = {}) {
    this.locale = e, this.formatter = new Intl.NumberFormat(e, t), this.options = this.formatter.resolvedOptions(), this.symbols = Fe(e, this.formatter, this.options, t);
    var r, n;
    this.options.style === "percent" && (((r = this.options.minimumFractionDigits) !== null && r !== void 0 ? r : 0) > 18 || ((n = this.options.maximumFractionDigits) !== null && n !== void 0 ? n : 0) > 18) && console.warn("NumberParser cannot handle percentages with greater than 18 decimal places, please reduce the number in your options.");
  }
}
const C = /* @__PURE__ */ new Set([
  "decimal",
  "fraction",
  "integer",
  "minusSign",
  "plusSign",
  "group"
]), we = [
  0,
  4,
  2,
  1,
  11,
  20,
  3,
  7,
  100,
  21,
  0.1,
  1.1
];
function Fe(i, e, t, r) {
  var n, o, m, l;
  let h = new Intl.NumberFormat(i, {
    ...t,
    // Resets so we get the full range of symbols
    minimumSignificantDigits: 1,
    maximumSignificantDigits: 21,
    roundingIncrement: 1,
    roundingPriority: "auto",
    roundingMode: "halfExpand"
  }), u = h.formatToParts(-10000.111), $ = h.formatToParts(10000.111), c = we.map((a) => h.formatToParts(a));
  var d;
  let b = (d = (n = u.find((a) => a.type === "minusSign")) === null || n === void 0 ? void 0 : n.value) !== null && d !== void 0 ? d : "-", p = (o = $.find((a) => a.type === "plusSign")) === null || o === void 0 ? void 0 : o.value;
  !p && ((r == null ? void 0 : r.signDisplay) === "exceptZero" || (r == null ? void 0 : r.signDisplay) === "always") && (p = "+");
  let f = (m = new Intl.NumberFormat(i, {
    ...t,
    minimumFractionDigits: 2,
    maximumFractionDigits: 2
  }).formatToParts(1e-3).find((a) => a.type === "decimal")) === null || m === void 0 ? void 0 : m.value, N = (l = u.find((a) => a.type === "group")) === null || l === void 0 ? void 0 : l.value, g = u.filter((a) => !C.has(a.type)).map((a) => L(a.value)), x = c.flatMap((a) => a.filter((s) => !C.has(s.type)).map((s) => L(s.value))), y = [
    .../* @__PURE__ */ new Set([
      ...g,
      ...x
    ])
  ].sort((a, s) => s.length - a.length), v = y.length === 0 ? new RegExp("[\\p{White_Space}]", "gu") : new RegExp(`${y.join("|")}|[\\p{White_Space}]`, "gu"), E = [
    ...new Intl.NumberFormat(t.locale, {
      useGrouping: !1
    }).format(9876543210)
  ].reverse(), P = new Map(E.map((a, s) => [
    a,
    s
  ])), S = new RegExp(`[${E.join("")}]`, "g");
  return {
    minusSign: b,
    plusSign: p,
    decimal: f,
    group: N,
    literals: v,
    numeral: S,
    index: (a) => String(P.get(a))
  };
}
function D(i, e, t) {
  return i.replaceAll ? i.replaceAll(e, t) : i.split(e).join(t);
}
function L(i) {
  return i.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
}
var M = {};
M = {
  Empty: "فارغ"
};
var z = {};
z = {
  Empty: "Изпразни"
};
var _ = {};
_ = {
  Empty: "Prázdné"
};
var k = {};
k = {
  Empty: "Tom"
};
var G = {};
G = {
  Empty: "Leer"
};
var K = {};
K = {
  Empty: "Άδειο"
};
var j = {};
j = {
  Empty: "Empty"
};
var U = {};
U = {
  Empty: "Vacío"
};
var W = {};
W = {
  Empty: "Tühjenda"
};
var q = {};
q = {
  Empty: "Tyhjä"
};
var H = {};
H = {
  Empty: "Vide"
};
var O = {};
O = {
  Empty: "ריק"
};
var Y = {};
Y = {
  Empty: "Prazno"
};
var Z = {};
Z = {
  Empty: "Üres"
};
var J = {};
J = {
  Empty: "Vuoto"
};
var X = {};
X = {
  Empty: "空"
};
var Q = {};
Q = {
  Empty: "비어 있음"
};
var ee = {};
ee = {
  Empty: "Tuščias"
};
var te = {};
te = {
  Empty: "Tukšs"
};
var re = {};
re = {
  Empty: "Tom"
};
var ie = {};
ie = {
  Empty: "Leeg"
};
var se = {};
se = {
  Empty: "Pusty"
};
var ae = {};
ae = {
  Empty: "Vazio"
};
var ne = {};
ne = {
  Empty: "Vazio"
};
var oe = {};
oe = {
  Empty: "Gol"
};
var le = {};
le = {
  Empty: "Не заполнено"
};
var ue = {};
ue = {
  Empty: "Prázdne"
};
var me = {};
me = {
  Empty: "Prazen"
};
var ce = {};
ce = {
  Empty: "Prazno"
};
var de = {};
de = {
  Empty: "Tomt"
};
var pe = {};
pe = {
  Empty: "Boş"
};
var fe = {};
fe = {
  Empty: "Пусто"
};
var $e = {};
$e = {
  Empty: "空"
};
var be = {};
be = {
  Empty: "空白"
};
var ye = {};
ye = {
  "ar-AE": M,
  "bg-BG": z,
  "cs-CZ": _,
  "da-DK": k,
  "de-DE": G,
  "el-GR": K,
  "en-US": j,
  "es-ES": U,
  "et-EE": W,
  "fi-FI": q,
  "fr-FR": H,
  "he-IL": O,
  "hr-HR": Y,
  "hu-HU": Z,
  "it-IT": J,
  "ja-JP": X,
  "ko-KR": Q,
  "lt-LT": ee,
  "lv-LV": te,
  "nb-NO": re,
  "nl-NL": ie,
  "pl-PL": se,
  "pt-BR": ae,
  "pt-PT": ne,
  "ro-RO": oe,
  "ru-RU": le,
  "sk-SK": ue,
  "sl-SI": me,
  "sr-SP": ce,
  "sv-SE": de,
  "tr-TR": pe,
  "uk-UA": fe,
  "zh-CN": $e,
  "zh-TW": be
};
function Te(i) {
  return i && i.__esModule ? i.default : i;
}
function Le(i) {
  const e = R(void 0);
  let { value: t, textValue: r, minValue: n, maxValue: o, isDisabled: m, isReadOnly: l, isRequired: h, onIncrement: u, onIncrementPage: $, onDecrement: c, onDecrementPage: d, onDecrementToMin: b, onIncrementToMax: p } = i;
  const T = Ee(Te(ye), "@react-aria/spinbutton"), f = () => clearTimeout(e.current);
  I(() => () => f(), []);
  let N = (s) => {
    if (!(s.ctrlKey || s.metaKey || s.shiftKey || s.altKey || l))
      switch (s.key) {
        case "PageUp":
          if ($) {
            s.preventDefault(), $ == null || $();
            break;
          }
        // fallthrough!
        case "ArrowUp":
        case "Up":
          u && (s.preventDefault(), u == null || u());
          break;
        case "PageDown":
          if (d) {
            s.preventDefault(), d == null || d();
            break;
          }
        // fallthrough
        case "ArrowDown":
        case "Down":
          c && (s.preventDefault(), c == null || c());
          break;
        case "Home":
          b && (s.preventDefault(), b == null || b());
          break;
        case "End":
          p && (s.preventDefault(), p == null || p());
          break;
      }
  }, g = R(!1), x = () => {
    g.current = !0;
  }, y = () => {
    g.current = !1;
  }, v = r === "" ? T.format("Empty") : (r || `${t}`).replace("-", "−");
  I(() => {
    g.current && (ge("assertive"), xe(v, "assertive"));
  }, [
    v
  ]);
  const E = V((s) => {
    f(), u == null || u(), e.current = window.setTimeout(() => {
      (o === void 0 || isNaN(o) || t === void 0 || isNaN(t) || t < o) && E(60);
    }, s);
  }), P = V((s) => {
    f(), c == null || c(), e.current = window.setTimeout(() => {
      (n === void 0 || isNaN(n) || t === void 0 || isNaN(t) || t > n) && P(60);
    }, s);
  });
  let S = (s) => {
    s.preventDefault();
  }, { addGlobalListener: w, removeAllGlobalListeners: a } = ve();
  return {
    spinButtonProps: {
      role: "spinbutton",
      "aria-valuenow": t !== void 0 && !isNaN(t) ? t : void 0,
      "aria-valuetext": v,
      "aria-valuemin": n,
      "aria-valuemax": o,
      "aria-disabled": m || void 0,
      "aria-readonly": l || void 0,
      "aria-required": h || void 0,
      onKeyDown: N,
      onFocus: x,
      onBlur: y
    },
    incrementButtonProps: {
      onPressStart: () => {
        E(400), w(window, "contextmenu", S);
      },
      onPressEnd: () => {
        f(), a();
      },
      onFocus: x,
      onBlur: y
    },
    decrementButtonProps: {
      onPressStart: () => {
        P(400), w(window, "contextmenu", S);
      },
      onPressEnd: () => {
        f(), a();
      },
      onFocus: x,
      onBlur: y
    }
  };
}
export {
  De as $,
  Le as a
};
